#include <avr/io.h>
#include <avr/interrupt.h>
#include "cdef.h"
#include "CycleSystem.h"
#include <inttypes.h>
#include <stdlib.h>


uint8_t gui8_500us;  
uint8_t gui8_1ms;  
uint8_t gui8_10ms;
uint8_t gui8_100ms;  
uint8_t gui8_1s;
uint8_t gui8_Call500us;  
uint8_t gui8_Call1ms;  
uint8_t gui8_Call10ms;
uint8_t gui8_Call100ms;  
uint8_t gui8_Call1s;


CycSys_Callback gptrCycSys_Callback_All_500us_HP;
CycSys_Callback gptrCycSys_Callback_All_1ms_HP;
CycSys_Callback gptrCycSys_Callback_All_10ms_HP;
CycSys_Callback gptrCycSys_Callback_All_100ms_HP;
CycSys_Callback gptrCycSys_Callback_All_1s_HP;

CycSys_Callback gptrCycSys_Callback_All_500us_LP;
CycSys_Callback gptrCycSys_Callback_All_1ms_LP;
CycSys_Callback gptrCycSys_Callback_All_10ms_LP;
CycSys_Callback gptrCycSys_Callback_All_100ms_LP;
CycSys_Callback gptrCycSys_Callback_All_1s_LP;



/* ----------------------- High Priority ----------------------*/

inline void  CycSys_All_500us_HP(void)
{
  gui8_Call500us = 1;
  
  /* User Code Begin */

  if (gptrCycSys_Callback_All_500us_HP != NULL)
  {
    gptrCycSys_Callback_All_500us_HP();
  }
  
  
  /* User Code End */
}

inline void  CycSys_All_1ms_HP(void)
{
  gui8_Call1ms   = 1;
  
  /* User Code Begin */

  if (gptrCycSys_Callback_All_1ms_HP != NULL)
  {
    gptrCycSys_Callback_All_1ms_HP();
  }
  
  /* User Code End */
}

inline void  CycSys_All_10ms_HP(void)
{
  gui8_Call10ms  = 1;
  
  /* User Code Begin */

  if (gptrCycSys_Callback_All_10ms_HP != NULL)
  {
    gptrCycSys_Callback_All_10ms_HP();
  }
  
  /* User Code End */
}

inline void  CycSys_All_100ms_HP(void)
{
  gui8_Call100ms = 1; 
  
  /* User Code Begin */

  if (gptrCycSys_Callback_All_100ms_HP != NULL)
  {
    gptrCycSys_Callback_All_100ms_HP();
  }
  
  /* User Code End */ 
}

inline void  CycSys_All_1s_HP(void)
{
  gui8_Call1s    = 1;
  
  /* User Code Begin */

  if (gptrCycSys_Callback_All_1s_HP != NULL)
  {
    gptrCycSys_Callback_All_1s_HP();
  }
  
  /* User Code End */    
}


/* -------------------- Low Priority ----------------------*/

inline void  CycSys_All_500us_LP(void)
{
  /* User Code Begin */


  if (gptrCycSys_Callback_All_500us_LP != NULL)
  {
    gptrCycSys_Callback_All_500us_LP();
  }
  
  /* User Code End */    
  
  gui8_Call500us = 0;
}

inline void  CycSys_All_1ms_LP(void)
{
  /* User Code Begin */

  if (gptrCycSys_Callback_All_1ms_LP != NULL)
  {
    gptrCycSys_Callback_All_1ms_LP();
  }
  
  /* User Code End */    
  
  gui8_Call1ms  = 0;
}

inline void  CycSys_All_10ms_LP(void)
{
  /* User Code Begin */

  if (gptrCycSys_Callback_All_10ms_LP != NULL)
  {
    gptrCycSys_Callback_All_10ms_LP();
  }

  
  /* User Code End */    
  
  gui8_Call10ms  = 0;
}

inline void  CycSys_All_100ms_LP(void)
{
  /* User Code Begin */
  
  if (gptrCycSys_Callback_All_100ms_LP != NULL)
  {
    gptrCycSys_Callback_All_100ms_LP();
  }
  
  /* User Code End */    
  
  gui8_Call100ms = 0; 
}

inline void  CycSys_All_1s_LP(void)
{
  /* User Code Begin */
 
  if (gptrCycSys_Callback_All_1s_LP != NULL)
  {
    gptrCycSys_Callback_All_1s_LP();
  }
  
  /* User Code End */    
  
  gui8_Call1s    = 0;
}

//Dieser Interrupt sollte alle 250us aufgerufen werden
// !!! Wird alle 256us aufgerufen @8Mhz
SIGNAL(TIMER0_OVF_vect)
{
  static uint8_t lui8_250us = 0; 
  static uint8_t lui8_500us = 0;  

  static uint8_t lui8_1ms = 0;  
  static uint8_t lui8_1ms_10 = 10;  
  
  static uint8_t lui8_10ms = 0;
  static uint8_t lui8_10ms_10 = 10;
  
  static uint8_t lui8_100ms = 0;  
  static uint8_t lui8_100ms_10 = 10;
  
  static uint8_t lui8_1s = 0;
  
  lui8_250us++;
  
  if (lui8_250us & 1) 
  {
    lui8_500us++;  
    gui8_500us++;
  
    CycSys_All_500us_HP();
      
    if (lui8_500us & 1) 
    {
      lui8_1ms++;
      gui8_1ms++;      
      lui8_1ms_10--;
      
      CycSys_All_1ms_HP();
        
      if (lui8_1ms_10 == 0)
      {
        lui8_1ms_10 = 10;      
        lui8_10ms++;        
        gui8_10ms++;      
        lui8_10ms_10--;
        
        CycSys_All_10ms_HP();
        
        if (lui8_10ms_10 == 0)
        {
          lui8_10ms_10 = 10;
          lui8_100ms++;
          gui8_100ms++;        
          lui8_100ms_10--;
          
          CycSys_All_100ms_HP();  
          
          if (lui8_100ms_10 == 0)
          {
            lui8_100ms_10  = 10;          
            lui8_1s++;
            gui8_1s++;    
  
            CycSys_All_1s_HP();
          }
        }    
      }
    }
  }
}


inline void CycSys_Start(CycSys_Callback lptrCycSys_Callback_All_500us_HP,
                         CycSys_Callback lptrCycSys_Callback_All_1ms_HP,
                         CycSys_Callback lptrCycSys_Callback_All_10ms_HP,
                         CycSys_Callback lptrCycSys_Callback_All_100ms_HP,
                         CycSys_Callback lptrCycSys_Callback_All_1s_HP,

                         CycSys_Callback lptrCycSys_Callback_All_500us_LP,
                         CycSys_Callback lptrCycSys_Callback_All_1ms_LP,
                         CycSys_Callback lptrCycSys_Callback_All_10ms_LP,
                         CycSys_Callback lptrCycSys_Callback_All_100ms_LP,
                         CycSys_Callback lptrCycSys_Callback_All_1s_LP)
{

  gui8_Call500us = 0;  
  gui8_Call1ms   = 0;
  gui8_Call10ms  = 0;
  gui8_Call100ms = 0;  
  gui8_Call1s    = 0;


  gptrCycSys_Callback_All_500us_HP = lptrCycSys_Callback_All_500us_HP;
  gptrCycSys_Callback_All_1ms_HP   = lptrCycSys_Callback_All_1ms_HP;
  gptrCycSys_Callback_All_10ms_HP  = lptrCycSys_Callback_All_10ms_HP;
  gptrCycSys_Callback_All_100ms_HP = lptrCycSys_Callback_All_100ms_HP;
  gptrCycSys_Callback_All_1s_HP    = lptrCycSys_Callback_All_1s_HP;


  gptrCycSys_Callback_All_500us_LP = lptrCycSys_Callback_All_500us_LP;
  gptrCycSys_Callback_All_1ms_LP   = lptrCycSys_Callback_All_1ms_LP;
  gptrCycSys_Callback_All_10ms_LP  = lptrCycSys_Callback_All_10ms_LP;
  gptrCycSys_Callback_All_100ms_LP = lptrCycSys_Callback_All_100ms_LP;
  gptrCycSys_Callback_All_1s_LP    = lptrCycSys_Callback_All_1s_LP;


   
  // Timer0 ist ein 8 Bit Timer
  // Timer0 wird alle 256us @8MHz einen Overflow bekommen, wenn der Prescaler auf 8 steht
  TCCR0 =  /* 4 + */   /* CS02:0: Clock Select => 8*/
              2 /*+*/  /* CS02:0: Clock Select => 8*/
           /* 1   */;  /* CS02:0: Clock Select => 8*/
  TCNT0 = 0;           /* Auf Null setzen */
  TIMSK |= _BV(TOIE0); /* Interupt bei Overflow */
}


inline void CycSys_Idle(void)
{
  if (gui8_Call500us) CycSys_All_500us_LP();
  if (gui8_Call1ms)   CycSys_All_1ms_LP();
  if (gui8_Call10ms)  CycSys_All_10ms_LP();
  if (gui8_Call100ms) CycSys_All_100ms_LP();
  if (gui8_Call1s)    CycSys_All_1s_LP();
}
